
/*---------------------------------------------------------------------------
							qfits test suite
 ---------------------------------------------------------------------------*/

/*
	$Id: test_stress.c,v 1.4 2002/04/16 13:53:34 ndevilla Exp $
	$Author: ndevilla $
	$Date: 2002/04/16 13:53:34 $
	$Revision: 1.4 $
*/

/*---------------------------------------------------------------------------
   								Includes
 ---------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>
#include <glob.h>

#include "qfits.h"
#include "xmemory.h"

int process_dir(char * dirname)
{
    char    pattern[FILENAMESZ];
	int	    err ;
    glob_t  pglob ;
    int     i ;
    qfits_header * qh ;

    err=0 ;
    sprintf(pattern, "%s/*.fits", dirname);
    glob(pattern, GLOB_MARK, NULL, &pglob);
    sprintf(pattern, "%s/*.FITS", dirname);
    glob(pattern, GLOB_APPEND, NULL, &pglob);
    sprintf(pattern, "%s/*.fits.gz", dirname);
    glob(pattern, GLOB_APPEND, NULL, &pglob);
    sprintf(pattern, "%s/*.FITS.gz", dirname);
    glob(pattern, GLOB_APPEND, NULL, &pglob);
    for (i=0 ; i<pglob.gl_pathc ; i++) {
        qh = qfits_header_read(pglob.gl_pathv[i]);
        if (qh==NULL) {
            printf("error loading %s\n", pglob.gl_pathv[i]);
            err++ ;
        } else {
            printf("header Ok: %s\n", pglob.gl_pathv[i]);
            qfits_header_destroy(qh);
        }
    }
    return err ;
}

int main(int argc, char * argv[])
{
	int	    err ;
	err=0 ;

    if (argc<2) {
        printf("use: %s <dirname>\n", argv[0]);
        return 1 ;
    }
    err += process_dir(argv[1]);
    err += process_dir(argv[1]);
    err += process_dir(argv[1]);
    err += process_dir(argv[1]);
    err += process_dir(argv[1]);
	fprintf(stderr, "total error(s): %d\n", err);
	return err ;
}
